' OxygenTestPB.bas
' Oxygen Assembler 'Asmosphere' project
' Charles E V Pegge
' 19 April 2008

    'PB interface
     MACRO zstring=ASCIIZ
     DECLARE FUNCTION o2_asm       LIB "oxygen.dll" ALIAS "o2_asm"       (zstring) AS STRING   ' assemble
     DECLARE FUNCTION o2_link      LIB "oxygen.dll" ALIAS "o2_link"      (zstring) AS STRING   ' o2 link **
     DECLARE FUNCTION o2_view      LIB "oxygen.dll" ALIAS "o2_view"      (zstring) AS STRING   ' o2 coding
     DECLARE FUNCTION o2_asm_file  LIB "oxygen.dll" ALIAS "o2_asm_file"  (zstring) AS STRING   ' assemble from file
     DECLARE FUNCTION o2_view_file LIB "oxygen.dll" ALIAS "o2_view_file" (zstring) AS STRING   ' o2 coding from file
     DECLARE FUNCTION o2_error     LIB "oxygen.dll" ALIAS "o2_error"     ()        AS STRING   ' error message if any
     DECLARE FUNCTION o2_len       LIB "oxygen.dll" ALIAS "o2_len"       ()        AS LONG     ' length of returned string
     DECLARE FUNCTION o2_buf       LIB "oxygen.dll" ALIAS "o2_buf"       (BYVAL LONG)AS LONG   ' buffer selector (returns pointer)
     ' ** o2_link is automatically called by o2_asm when the assembly is successful.

FUNCTION PBMAIN()

    DIM p   AS BYTE PTR
    DIM src AS STRING
    DIM cod AS STRING
    DIM lst AS STRING
    DIM erm AS STRING
    DIM r AS LONG
    DIM i AS LONG
    o2_buf(1)                          ' optional buffer number 0..511
    src="inc eax"+$CR+"ret"            ' minimal source code
    lst=LEFT$(o2_view((src)),o2_len()) ' view assembled code
    cod=LEFT$(o2_asm((src)),o2_len())  ' compile code string
    erm=LEFT$(o2_error(),o2_len())     ' check for any error
    IF erm="" THEN
        i=41
        p=STRPTR(cod)                  ' get pointer to code string
        ! mov eax,i                    ' pass a parameter
        ! call p ' execute code        ' call the code
        ! mov r,eax                    ' store the result
    END IF
    MSGBOX "Result:"+STR$(r)+$CR+$CR+lst

   FUNCTION=0

END FUNCTION
