' OxygenTestFB.bas
' Oxygen Assembler 'Asmosphere' project
' Charles E V Pegge
' 19 April 2008

Extern "Windows-MS"
     DECLARE FUNCTION o2_asm       LIB "oxygen.dll" ALIAS "o2_asm"       (byval as zstring ptr) AS long ' assemble
     DECLARE FUNCTION o2_link      LIB "oxygen.dll" ALIAS "o2_link"      (byval as zstring ptr) AS long ' o2 link **
     DECLARE FUNCTION o2_view      LIB "oxygen.dll" ALIAS "o2_view"      (byval as zstring ptr) AS long ' o2 coding
     DECLARE FUNCTION o2_asm_file  LIB "oxygen.dll" ALIAS "o2_asm_file"  (byval as zstring ptr) AS long ' assemble from file
     DECLARE FUNCTION o2_view_file LIB "oxygen.dll" ALIAS "o2_view_file" (byval as zstring ptr) AS long ' o2 coding from file
     DECLARE FUNCTION o2_error     LIB "oxygen.dll" ALIAS "o2_error"     ()                     AS long ' error message if any
     DECLARE FUNCTION o2_len       LIB "oxygen.dll" ALIAS "o2_len"       ()                     AS long ' length of returned string
     DECLARE FUNCTION o2_buf       LIB "oxygen.dll" ALIAS "o2_buf"       (byval as long)        AS long ' buffer selector 0..511 (returns pointer)
End Extern

     ' ** o2_link is automatically called by o2_asm when the assembly is successful.


function gets(byval p as long) as string
    dim s as string
    dim l as long
    dim q as any ptr
    l=o2_len()
    s=space(l)
    if l=0 then goto xgets
    q=strptr(s)
    asm
        mov ecx,[l]
        mov esi,[p]
        mov edi,[q]
        strpt:
            mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            dec ecx
        jg strpt 
    end asm
    xgets:
    function=s
end function
  

    dim src AS STRING   ' source
    dim cod AS STRING   ' code
    dim lst AS STRING   ' listing
    dim erm AS STRING   ' error message
    dim p   as any ptr  ' pointer to code string
    dim r   AS LONG     ' result
    dim i   AS LONG     ' input param

    dim cr as string = chr$(13)+chr$(10)
    o2_buf(1)                ' optional buffer number 0..511
    src="inc eax"+cr+"ret"   ' minimal source code
    lst=gets(o2_view(src))   ' view assembled code
    cod=gets(o2_asm(src))    ' compile code string
    erm=gets(o2_error())     ' check for any error
    IF erm="" THEN
        i=41
        p=STRPTR(cod)        ' get pointer to code string
        asm
          mov eax,[i]        ' pass a parameter
          call [p]           ' call the code
          mov [r],eax        ' store the result
        end asm
    END IF

    print "Result: ";r
    print
    print "listing:"
    print lst

while inkey$="":wend

end
